//
//  TransactionsPresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/5/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import RxCocoa
import RxSwift


protocol TransactionsWireframeInterface: WireframeInterface {
    func detachTransactions()
}

protocol TransactionsViewInterface: ViewInterface {
}

final class TransactionsPresenter: TransactionsPresenterInterface {
    
    let backTrigger = PublishRelay<Void>()
    // MARK: - Private properties -
    
    private let disposeBag = DisposeBag()
    
    private unowned let view: TransactionsViewInterface
    private let interactor: TransactionsInteractorInterface
    private let wireframe: TransactionsWireframeInterface
    
    // MARK: - Lifecycle -
    
    init(view: TransactionsViewInterface, interactor: TransactionsInteractorInterface, wireframe: TransactionsWireframeInterface) {
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
        configureViewActions()
    }
}

// MARK: - Extensions -

extension TransactionsPresenter {
    private func configureViewActions() {
        backTrigger
            .subscribeNext { [weak wireframe] in
                wireframe?.detachTransactions()
            }
            .disposed(by: disposeBag)
    }
}
